<template>
  <div :class="['entry-expandable', { 'is-open': isOpen }]">
    <div class="wrapper-button-expandable">
      <button
        :id="props.slug"
        @click="copyToClipboard(`#${props.slug}`)"
        class="button-anchor"
      >
        <img
          src="@/assets/images/lien.svg"
          loading="lazy"
          class="subtitle-button-img"
        />
      </button>
      <button type="button" @click="isOpen = !isOpen" class="button-expandable">
        <h3 class="title">{{ props.title }}</h3>
        <img
          src="@/assets/images/chevron.svg"
          loading="lazy"
          class="image-chevron"
        />
      </button>
    </div>
    <div class="article-wrapper">
      <p v-html="props.text" class="article-text"></p>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, onMounted } from 'vue'
import { copyToClipboard } from '@/utils/slug'
import { useRoute } from 'vue-router'
interface Props {
  title: string
  text: string
  slug: string
}
const route = useRoute()
const props = defineProps<Props>()
const isOpen = ref<boolean>(false)
onMounted(() => {
  if (route.hash.length && route.hash === `#${props.slug}`) isOpen.value = true
})
</script>

<style scoped>
.entry-expandable {
  background-color: var(--white);
  border-radius: 1rem;
  overflow: hidden;
  margin-bottom: 2rem;
}
.title {
  font-family: SFPro;
  font-size: 1.8rem;
  color: var(--blue-dark);
  margin-right: 2rem;
  text-align: initial;
}
.button-anchor,
.button-expandable {
  border: none;
  background: transparent;
  cursor: pointer;
}
.button-anchor {
  height: 3.5rem;
  width: 3.5rem;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
}
.button-anchor:hover {
  background-color: var(--blue-pale);
}
.subtitle-button-img {
  width: 100%;
}
.wrapper-button-expandable {
  display: flex;
  align-items: center;
  text-align: left;
  padding: 1.5rem 2rem;
  background-color: transparent;
  width: 100%;
}
.button-expandable {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
}
.article-text {
  font-size: 1.6rem;
  line-height: 1.5;
  white-space: pre-wrap;
  padding-left: 1.5rem;
  padding-right: 1.5rem;
  padding-bottom: 1.5rem;
  color: var(--grey-dark);
}
.article-wrapper {
  max-height: 0rem;
  transition: max-height, 0.3s;
}
.is-open .article-wrapper {
  transition: max-height, 0.7s;
  max-height: 100rem;
}
.is-open .image-chevron {
  transform: rotate(0deg);
  transition: transform, 0.6s;
}
.image-chevron {
  transform: rotate(180deg);
  transition: transform, 0.6s;
  height: 1rem;
}
@media (max-width: 768px) {
  .title {
    font-size: 1.6rem;
  }
  .article-text {
    font-size: 1.4rem;
  }
  .button-expandable {
    padding: 0 0 0 2rem;
  }
  .button-anchor {
    position: absolute;
    width: 2rem;
    left: 1rem;
    padding: 0;
  }
}
</style>
